format pe gui 4.0
entry start

include '%fasminc%\win32a.inc'

MAX_PATH	= 260

section '.idata' data readable writeable

  szExe 		db "*secret*.exe",0

  szError		db "Error",0
  szOpenErrorMsg	db "Could not create target process!",0
  szWriteErrorMsg	db "Could not write to target process!",0


  Address2Check 	dd 0041B4E9h
  Bytes2Check		dd 1
  Ready2Patch		db 074h

  Address2Patch 	dd 0041B4E9h
  Bytes2Patch		db 090h,090h
  Size2Patch		dd 2

section '.udata' readable writeable

  pinf		PROCESS_INFORMATION
  sinf		STARTUPINFO

  CheckSizeBuffer  rb 1

section '.code' code readable writable executable

  start:
	xor	ebx,ebx
	mov	[sinf.cb],sizeof.STARTUPINFO
	invoke	CreateProcess,szExe,ebx,ebx,ebx,ebx,020h,ebx,ebx,sinf,pinf
	test	eax,eax
	jz	.OpenError


  .Check4ByteSig:
	invoke	ReadProcessMemory,[pinf.hProcess],[Address2Check],CheckSizeBuffer,[Bytes2Check],ebx
	test	eax,eax
	jz	.Check4ByteSig

	cld
	lea	esi,[CheckSizeBuffer]
	lea	edi,[Ready2Patch]
	mov	ecx,1
	rep	cmpsb
	jnz	.Check4ByteSig

	invoke	SuspendThread,[pinf.hThread]

	invoke	WriteProcessMemory,[pinf.hProcess],[Address2Patch],Bytes2Patch,[Size2Patch],ebx
	test	eax,eax
	jz	.WriteError

	invoke	ResumeThread,[pinf.hThread]

  .CloseProgram:
	invoke	CloseHandle,[pinf.hProcess]
	invoke	CloseHandle,[pinf.hThread]

  .Exit:
	invoke	ExitProcess,ebx

  .OpenError:
	lea	eax,[szOpenErrorMsg]
	jmp	.Terminate

  .WriteError:
	lea	eax,[szWriteErrorMsg]

  .Terminate:
	invoke	MessageBox,ebx,eax,szError,MB_OK+MB_ICONHAND
	jmp	.CloseProgram

section '.idata' import data readable writeable

  library	kernel32,'kernel32.dll',\
		user32,'user32.dll',\
		gdi32,'gdi32.dll',\
		comdlg32,'comdlg32.dll'

  include	'%fasminc%\apia\kernel32.inc'
  include	'%fasminc%\apia\user32.inc'
  include	'%fasminc%\apia\gdi32.inc'
  include	'%fasminc%\apia\comdlg32.inc'

; eof